/*Tutor. Paolo Pasteris
  ProgettoMM 11/12 Unimi
  de Chirico
*/
import codeanticode.gsvideo.*;
import java.awt.Color;

GSCapture cam;
PImage back, front;
float targetHue;
float Htollerance,
      Stollerance,
      Vtollerance;

void setup() 
{
   size(320, 240);
   cam = new GSCapture(this, width, height);
   cam.start();
   back= loadImage("back.jpg");
   front= loadImage("front.png");
   targetHue=134f/360f;
   Htollerance=0.15f;
   Stollerance=0.5f;
   Vtollerance=0.2;
}
void draw() 
{
    if (cam.available()) 
    {
        image(back,0,0);
        cam.read();
        image(chromaKey(cam),0,0);
        image(front,0,0);
        
    }
}

PImage chromaKey(PImage layer){
  int dimension=layer.width*layer.height;
  int r,g,b;
  float[] hsb=new float[3];
  float deltaHue,alpha_channel;
  PImage alphaImage=createImage(layer.width,layer.height,ARGB); 
  
  layer.loadPixels();
  alphaImage.loadPixels();
  
  for(int i=0;i<dimension;i++){
    //Color space convertion
    Color.RGBtoHSB((int)red(layer.pixels[i]),(int)green(layer.pixels[i]),(int)blue(layer.pixels[i]), hsb);
    //Hue difference
    deltaHue = Math.abs(hsb[0]-targetHue);
    if(deltaHue < Htollerance && hsb[1]> Stollerance && hsb[2]> Vtollerance){
      alpha_channel=0;      
    }else{
      alpha_channel=1;
    }   
    alphaImage.pixels[i]=color(red(layer.pixels[i]),green(layer.pixels[i]),blue(layer.pixels[i]),alpha_channel*255);
  }
  alphaImage.updatePixels();
  //alphaImage.resize(layer.width/2,layer.height/2);
  return alphaImage;
}
